/* -----------------------------------------------------------------------------
*
*  nppy.c
*
*  ANTz - realtime 3D data visualization tools for the real-world, based on NPE.
*
*  ANTz is hosted at http://openantz.com and NPE at http://neuralphysics.org
*
*  Written in 2010-2016 by Shane Saxon - saxon@openantz.com
*
*  Please see main.c for a complete list of additional code contributors.
*
*  To the extent possible under law, the author(s) have dedicated all copyright 
*  and related and neighboring rights to this software to the public domain
*  worldwide. This software is distributed without any warranty.
*
*  Released under the CC0 license, which is GPL compatible.
*
*  You should have received a copy of the CC0 Public Domain Dedication along
*  with this software (license file named LICENSE.txt). If not, see
*  http://creativecommons.org/publicdomain/zero/1.0/
*
* --------------------------------------------------------------------------- */

#include "nppy.h"


#include <Python.h>


//------------------------------------------------------------------------------
void npPyInit (void* dataRef)
{
	//PyArg_ParseTuple(
	//PyEval_CallObject(NULL, NULL);
	Py_Initialize();
	return;
}

void npPyClose (void* dataRef)
{
	Py_Finalize();
}

PyObject* npPyStr(char* str, void* dataRef);
PyObject* npPyStr(char* str, void* dataRef)
{
	PyObject* pStr = NULL;
    pStr = PyString_FromString("np");
	return pStr;
}

PyObject* npPyImport(char* module, void* dataRef);
PyObject* npPyImport(char* module, void* dataRef)
{
	PyObject* pStr = NULL;
	PyObject* pMod = NULL;
	pStr = npPyStr(module, dataRef);
	pMod = PyImport_Import(pStr);	
	
	Py_DECREF(pStr);
	return pMod;
}

PyObject* npPyModuleGetDict(PyObject* pModule, void* dataRef);
PyObject* npPyModuleGetDict(PyObject* pModule, void* dataRef)
{
	PyObject* pDict = NULL;
	pDict = PyModule_GetDict(pModule);
	return pDict;
}

//	pFunc = PyDict_GetItemString(pDict, "npPy");
PyObject* npPyDictGetItemStr(PyObject* pDict, char* item, void* dataRef);
PyObject* npPyDictGetItemStr(PyObject* pDict, char* item, void* dataRef)
{
	PyObject* pItemStr = NULL;
	pItemStr = PyDict_GetItemString(pDict, item);
	return pItemStr;
}

//PyObject* npPyObjCallFunc(PyObject* func, 

void npPySelectNodeById(void* dataRef)
{

}

void npPyCtrlCmd(void* dataRef)
{
	PyObject *pModule = NULL;
	static long lastTime = 1;
	int newTime = 0;
	PyObject *newModule = NULL;
    PyObject *pName, *pDict, *pFunc;
    PyObject *pArgs, *pValue, *pInt, *pArgA, *pArgB;
	PyObject *listItem;
    int i;

    if (1 == 0) {
        fprintf(stderr,"Usage: call pythonfile funcname [args]\n");
        return 1;
    }

//	printf("Before Py_init\n");
    Py_Initialize();
//	printf("After Py_init : %s\n", Py_GetPath());
/*
	pArgA = PyInt_FromLong(9);
	pArgB = PyInt_FromLong(3);
	pArgs = PyTuple_New(2);

	PyTuple_SetItem(pArgs, 0, pArgA);
	PyTuple_SetItem(pArgs, 1, pArgB);
*/
	
	pModule = npPyImport("np", dataRef);

	pDict = npPyModuleGetDict(pModule, dataRef);

	pFunc = npPyDictGetItemStr(pDict, "npCtrlCmd", dataRef);
//	pInt = PyInt_FromLong(5);


	if(PyCallable_Check(pFunc))
	{
		pValue = PyObject_CallObject(pFunc, NULL);
		//pValue = PyObject_CallFunction(pFunc, NULL);
	}
	else
		PyErr_Print();

	if(PyList_Size(pValue))
	{	
		for(i = 0; i < PyList_Size(pValue); i++)
		{
	//		printf("item %d\n", i);
			listItem = PyList_GetItem(pValue, i);
		//	npSelectNodeByID( PyInt_AsLong(listItem), dataRef);
			npCtrlCommand( PyInt_AsLong(listItem), dataRef );
		}
	}

//	printf("pValue : %d\n", PyInt_AsLong(listItem));


	Py_DECREF(pModule);	 
//	Py_DECREF(pName);

	Py_Finalize();

	return;

}

void npPySelectTest(void* dataRef)
{
	PyObject *pModule = NULL;
	static long lastTime = 1;
	int newTime = 0;
	PyObject *newModule = NULL;
    PyObject *pName, *pDict, *pFunc;
    PyObject *pArgs, *pValue, *pInt, *pArgA, *pArgB;
	PyObject *listItem;
    int i;

    if (1 == 0) {
        fprintf(stderr,"Usage: call pythonfile funcname [args]\n");
        return 1;
    }

//	printf("Before Py_init\n");
    Py_Initialize();
//	printf("After Py_init : %s\n", Py_GetPath());
/*
	pArgA = PyInt_FromLong(9);
	pArgB = PyInt_FromLong(3);
	pArgs = PyTuple_New(2);

	PyTuple_SetItem(pArgs, 0, pArgA);
	PyTuple_SetItem(pArgs, 1, pArgB);
*/
	
	pModule = npPyImport("np", dataRef);

	pDict = npPyModuleGetDict(pModule, dataRef);

	pFunc = npPyDictGetItemStr(pDict, "npPy", dataRef);
//	pInt = PyInt_FromLong(5);


	if(PyCallable_Check(pFunc))
	{
		pValue = PyObject_CallObject(pFunc, NULL);
		//pValue = PyObject_CallFunction(pFunc, NULL);
	}
	else
		PyErr_Print();

	if(PyList_Size(pValue))
	{	
		for(i = 0; i < PyList_Size(pValue); i++)
		{
	//		printf("item %d\n", i);
			listItem = PyList_GetItem(pValue, i);
			npSelectNodeByID( PyInt_AsLong(listItem), dataRef);
		}
	}

//	printf("pValue : %d\n", PyInt_AsLong(listItem));


	Py_DECREF(pModule);	 
//	Py_DECREF(pName);

	Py_Finalize();

	return;
}

void npPyTest(void* dataRef)
{
    PyObject *pName, *pModule, *pDict, *pFunc;
    PyObject *pArgs, *pValue, *pInt, *pArgA, *pArgB;
    int i;

    if (1 == 0) {
        fprintf(stderr,"Usage: call pythonfile funcname [args]\n");
        return 1;
    }

	printf("Before Py_init\n");
    Py_Initialize();
	printf("After Py_init : %s\n", Py_GetPath());

	pArgA = PyInt_FromLong(9);
	pArgB = PyInt_FromLong(3);
	pArgs = PyTuple_New(2);

	PyTuple_SetItem(pArgs, 0, pArgA);
	PyTuple_SetItem(pArgs, 1, pArgB);

    pName = PyString_FromString("np");
	pModule = PyImport_Import(pName);
	pDict = PyModule_GetDict(pModule);

	pFunc = PyDict_GetItemString(pDict, "multiply");
//	pInt = PyInt_FromLong(5);


	if(PyCallable_Check(pFunc))
		pValue = PyObject_CallObject(pFunc, pArgs);
	else
		PyErr_Print();

	printf("pValue : %d\n", PyInt_AsLong(pValue));
	Py_DECREF(pModule);	 
	Py_DECREF(pName);

	Py_Finalize();

	return;
}

static PyObject* npPySelect(PyObject* self, PyObject* args)
{

}


void npPyExec(char* cmd, void* dataRef)
{
	PyRun_SimpleString(cmd);
}

//------------------------------------------------------------------------------
void npPyUpdate (void* dataRef)							//add to ctrl loop, debug zz
{
	return;
}

//------------------------------------------------------------------------------

/*
	static PyObject* npPySelectNodeId(PyObject* nodeID, void* dataRef???)
	{
		npSelectNodeByID( PyInt_FromLong(nodeID), dataRef );

	}
*/

static PyObject* helloworld(PyObject* self)
{
	return Py_BuildValue("s", "Hello, Python extensions!!");
}

static char helloworld_docs[] = 
"helloworld( ): Any message here!!\n";

static PyMethodDef helloworld_funcs[] = {
    {"helloworld", (PyCFunction)helloworld, 
     METH_NOARGS, helloworld_docs},
    {NULL}
};

void inithelloworld(void)
{
    Py_InitModule3("helloworld", helloworld_funcs,
                   "Extension module example!");
}

//------------------------------------------------------------------------------
    static PyObject *my_callback = NULL;

    static PyObject *
    my_set_callback(dummy, args)
        PyObject *dummy, *args;
    {
        PyObject *result = NULL;
        PyObject *temp;

        if (PyArg_ParseTuple(args, "O:set_callback", &temp)) {
            if (!PyCallable_Check(temp)) {
                PyErr_SetString(PyExc_TypeError, "parameter must be callable");
                return NULL;
            }
            Py_XINCREF(temp);         //Add a reference to new callback 
            Py_XDECREF(my_callback);  // Dispose of previous callback 
            my_callback = temp;       // Remember new callback 
            // Boilerplate to return "None" 
            Py_INCREF(Py_None);
            result = Py_None;
        }
        return result;
    }

